//Programmed by Christoph Kirschner
//Programmed for OhmDuino Vers.2
//10.12.18 21.36

#include <CapacitiveSensor.h>
CapacitiveSensor   cs_0_1 = CapacitiveSensor(A0, A1); //delcares touchsensor 1
CapacitiveSensor   cs_2_3 = CapacitiveSensor(A2, A3); //delcares touchsensor 2

int lastState1 = 0; // last state of touchsensor
int lastState2 = 0; // last state of touchsensor
int lastUpdateTouch = 0;


byte cols[5] = {9, 10, 11, 12, 13}; //pins of the columns
byte rows[5] = {4, 5, 6, 7, 8}; //pins of the rows
byte posArray = 24; //position of the LED
byte bitMapNow = 0; //selected bitmap
int lastBitMapChange = 0;

bool bitMap1[25] = {1, 0, 1, 0, 1,
                    0, 1, 0, 1, 0,
                    1, 0, 1, 0, 1,
                    0, 1, 0, 1, 0,
                    1, 0, 1, 0, 1
                   }; //Bitmap to show on LEDs

bool bitMap2[25] = {0, 1, 0, 1, 0,
                    1, 0, 1, 0, 1,
                    0, 1, 0, 1, 0,
                    1, 0, 1, 0, 1,
                    0, 1, 0, 1, 0
                   }; //Bitmap to show on LEDs

void setup()
{
  //cs_0_1.set_CS_AutocaL_Millis(0xFFFFFFFF);
  //cs_2_3.set_CS_AutocaL_Millis(0xFFFFFFFF);

  pinMode(A0, OUTPUT);
  pinMode(A2, OUTPUT);
  pinMode(A1, INPUT);
  pinMode(A3, INPUT);

  for (int i = 4; i < 14; i++) { //declares pins as outputs
    pinMode(i, OUTPUT);
  }

  for (int i = 0; i < 5; i++) {
    digitalWrite (cols[i], HIGH); //sets all column-pins to HIGH
    digitalWrite (rows[i], LOW);  //sets all row-pins to LOW
  }
}

void loop() {
  showLEDs();
  touch();
}

void touch () {
  int t = millis();
  if (t - lastUpdateTouch > 300) {
    int total1 =  cs_0_1.capacitiveSensor(20); //reads touchsensor 1 and saves value
    int total2 =  cs_2_3.capacitiveSensor(20); //reads touchsensor 2 and saves value

    if ( total1 > 30 && lastState1 < 20 ) { //compares the touch-values with a threshold
      if (bitMapNow == 0) { //changes selected bitmap
        bitMapNow++;
      } else {
        bitMapNow = 0;
      }
    } else if (total2 > 30 && lastState2 < 20) {
      if (bitMapNow == 0) { //changes selected bitmap
        bitMapNow++;
      } else {
        bitMapNow = 0;
      }
    }
    lastState1 = total1;
    lastState2 = total2;
  
  lastUpdateTouch = millis();
  }
}


void showLEDs() { //manages the multiplexing
  for (int x = 0; x < 5; x++) { //save column-position
    digitalWrite (cols[x], LOW); //reset GIPO of column
    for (int y = 0; y < 5; y++) { //save row-position
      if (selectBitmap () == true) { //check if the LED is declared to be on in the bitmap
        digitalWrite (rows[y], HIGH); //set GPIO of row
        delay(1);
        digitalWrite (rows[y], LOW);  //reset GPIO of row
      }
      if (posArray > 0) {
        posArray--;
      } else {
        posArray = 24;
      }
    }
    digitalWrite (cols[x], HIGH); //reset GPIO of column
  }
}

bool selectBitmap () { //selects the bitmap
  switch (bitMapNow) {
    case 0:
      return bitMap1[posArray];
      break;

    case 1:
      return bitMap2[posArray];
      break;
  }
}



